<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ page import="org.wso2.carbon.registry.common.ui.UIException" %>                            
<%@ page import="org.wso2.carbon.registry.core.RegistryConstants" %>
<%@ page import="org.wso2.carbon.governance.services.ui.utils.AddServicesUtil" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.registry.extensions.utils.CommonUtil" %>
<%@ page import="org.wso2.carbon.governance.services.ui.utils.AddServiceUIGenerator" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.wso2.carbon.governance.services.ui.clients.AddServicesServiceClient" %>
<%@ page import="org.wso2.carbon.registry.extensions.utils.CommonConstants" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="org.wso2.carbon.registry.core.utils.RegistryUtils" %>
<%
    String error1 = "Your modification cause replacement of another resource!";
    String error2 = "Unable to add the given service";
    AddServiceUIGenerator uigen = new AddServiceUIGenerator();
    AddServicesServiceClient client = new AddServicesServiceClient(config,session);
    String servicePath = client.getServicePath();
    OMElement head = null;
    //check whether this is adding a new service or this is editing the service content
    if(request.getAttribute("content") == null){
        head = uigen.getUIConfiguration(client.getServiceConfiguration(),request,config,session);
    }
    else{
        head = (OMElement)request.getAttribute("content");
    }

    String namespace = request.getParameter("Overview_Namespace");
    String serviceName = request.getParameter("Overview_Name");
    String version;
    String registryServicePath = null;
    try {
        if (!head.getChildrenWithLocalName("newServicePath").hasNext()) {
            servicePath = AddServicesUtil.getServicePath(config,session);
        }
        else{
            Iterator it = head.getChildrenWithLocalName("newServicePath");
            while (it.hasNext()) {
                OMElement omElement = (OMElement) it.next();
                servicePath = omElement.getText();
                break;
            }
        }
        if (AddServicesUtil.addServiceContent(head,request,config,session)){

            //This is to check whether the user has modified the name and the namespace of the service
            String newName = request.getParameter("newname");
            String newnamespace = request.getParameter("newnamespace");

            serviceName = (serviceName != newName) ? newName : serviceName;
            namespace = (namespace != newnamespace) ? newnamespace : namespace;

            String tempnamespace = null;
            if(namespace.startsWith("/")){
                tempnamespace = namespace;
                if(!tempnamespace.endsWith(RegistryConstants.PATH_SEPARATOR)){
                    tempnamespace = new StringBuilder().append(tempnamespace).append(RegistryConstants.PATH_SEPARATOR).toString();
                }
            }
            else{
                tempnamespace = CommonUtil.derivePathFragmentFromNamespace(namespace);
            }
            String effectivePath;
            version = request.getParameter("Overview_Version");

            String defaultServicePath = RegistryUtils.getRelativePathToOriginal(AddServicesUtil.getServicePath(config,session)
                                , RegistryConstants.GOVERNANCE_REGISTRY_BASE_PATH);


            if (servicePath.contains(defaultServicePath)) {
                effectivePath = servicePath + tempnamespace + serviceName;
            } else {
                if (version == null || version.trim().equals("")) {
                    effectivePath = CommonUtil.computeServicePathWithVersion(servicePath + tempnamespace + serviceName, CommonConstants.SERVICE_VERSION_DEFAULT_VALUE);
                } else {
                    effectivePath = CommonUtil.computeServicePathWithVersion(servicePath + tempnamespace + serviceName, version);
                }
            }
            try {
//                if(request.getParameter("path")!=null){
//                    effectivePath = request.getParameter("path");
//                }
                registryServicePath = effectivePath.replaceAll("&", "%26");
            } catch (Exception ignore) {}
            String resourcePagePath = "../resources/resource.jsp?region=region3&item=resource_browser_menu&path=" + registryServicePath;
            response.sendRedirect(resourcePagePath);
        }else{
            request.setAttribute(CarbonUIMessage.ID,new CarbonUIMessage(error1,error1,null));
            CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, error1, null);
            session.setAttribute(CarbonUIMessage.ID, uiMsg);

%>

<jsp:forward page="../admin/error.jsp"/>

<%}
} catch (Exception e) {
%>
    <script type="text/javascript">
       window.location = "../services/services.jsp?region=region3&item=governance_services_menu&wsdlError=" + encodeURIComponent("<%=e.getMessage()%>");
    </script><%
    return;
}
%>



    
